/***********************************************
 *
 * Angelscript Dumper v2.1 by learn_more
 * File: out\a172\script\cam_dump.as
 * Generated: 25-Mar-2012 22:14:50
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x39a570 (0x79a570)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xba910 (0x4ba910)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xba940 (0x4ba940)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x39a9f0 (0x79a9f0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x39b130 (0x79b130)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x39aec0 (0x79aec0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x39adb0 (0x79adb0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x39b190 (0x79b190)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x39ac80 (0x79ac80)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x39a9a0 (0x79a9a0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x39b160 (0x79b160)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x39aa20 (0x79aa20)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x39ab50 (0x79ab50)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x39a5c0 (0x79a5c0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x39a0c0 (0x79a0c0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x233c60 (0x633c60)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x232b30 (0x632b30)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x232b90 (0x632b90)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x233a70 (0x633a70)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x233ae0 (0x633ae0)
	void Update();		// 'Overgrowth.exe' + 0x237720 (0x637720)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x28f4c0 (0x68f4c0)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x28f470 (0x68f470)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x35cf10 (0x75cf10)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x35cd70 (0x75cd70)
	quaternion GetRotation();		// 'Overgrowth.exe' + 0x35cd30 (0x75cd30)
	float GetLens();		// 'Overgrowth.exe' + 0x35cd50 (0x75cd50)
	void Update();		// 'Overgrowth.exe' + 0x35bef0 (0x75bef0)
	bool valid();		// 'Overgrowth.exe' + 0x35b2b0 (0x75b2b0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;
SphereCollision sphere_col;
GUI gui;
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x40c5a4 (0x80c5a4)
CameraObject co;
CameraAnimationReader camera_animation_reader;
